#ifndef libSTDIO_H
#define libSTDIO_H
#include "../CDC_library/inc/aeabi_unwind.h"
#include <stdio.h>
#include "../CMSISv2P00_LPC13xx/inc/LPC13Uxx.h" 
#include "../CDC_library/inc/CDC.h"
//#include "../CDC_library/inc/cdc_desc.h"
#define NOT_USED(x) ((void)(x))

#undef putchar
#define putchar(x) __sys_writec(x)
#undef getchar
#define getchar() get_char()

#define CDC		0
#define UART  	1
#define BRIDGE	2

#define BLUE	8
#define GREEN	9
#define RED		10

#define RED_LED()	LPC_GPIO->B0[RED] &= ~1;LPC_GPIO->B0[GREEN] |= 1;LPC_GPIO->B0[BLUE] |= 1;		
#define GREEN_LED()	LPC_GPIO->B0[GREEN] &= ~1;LPC_GPIO->B0[RED] |= 1;LPC_GPIO->B0[BLUE] |= 1;
#define BLUE_LED()	LPC_GPIO->B0[BLUE] &= ~1;LPC_GPIO->B0[GREEN] |= 1;LPC_GPIO->B0[RED] |= 1;	
#define WHITE_LED()	LPC_GPIO->B0[BLUE] &= ~1;LPC_GPIO->B0[GREEN] &= ~1;LPC_GPIO->B0[RED] &= ~1;	
#define LED_OFF()	LPC_GPIO->B0[BLUE] |= 1;LPC_GPIO->B0[GREEN] |= 1;LPC_GPIO->B0[RED] |= 1;

#define RED_TOGGLE()	LPC_GPIO->B0[RED] ^= 1;	
#define GREEN_TOGGLE()	LPC_GPIO->B0[GREEN] ^= 1;	
#define BLUE_TOGGLE()	LPC_GPIO->B0[BLUE] ^= 1;	
#define WHITE_TOGGLE()	LPC_GPIO->B0[BLUE] ^= 1;LPC_GPIO->B0[GREEN] ^= 1;LPC_GPIO->B0[RED] ^= 1;

#if defined (__cplusplus)
extern "C" {
#endif

//Private
extern int __sys_readc(void);
extern void __sys_writec(char data);
extern char get_char(void);

//Public
extern void Comport_Init(char device,int baudrate);
extern char RxReady(void);
extern volatile int current_time;				//holds the current Ms count of SysTick

#if defined (__cplusplus)
}
#endif

#endif // libSTDIO_H 